#pragma once

#include <Figment.h>
#include <vector>

class Sequencer: public Task {
public:

    class Scene {
      public:
        const char* name;
        std::vector<const char*> patterns;
    };

    Sequencer(std::vector<Scene> &&scenes);
    Sequencer(std::vector<Scene> &&scenes, int startingIndex);

    void loop() override;
    void onStart() override;
    void handleEvent(const InputEvent& evt) override;

    const char* currentSceneName();
    const std::vector<Scene> scenes() const;

private:
    int m_idx;
    std::vector<Scene> m_scenes;
};
